<?php
include "api_exception.php";

function found_resource($path_items,$parent=null){
	$current = array_shift($path_items);	
	if( $parent != null ) 
	{
		$current = "$parent/$current";
	}
	if(is_file("inc/$current.inc.php"))
	{
		return array('path' =>"inc/$current.inc.php",'resource' => trim($current,'/'));
	}
	else if(is_dir($current) && !empty($path_items))
	{
		return found_resource($path_items,$current);
	}
	else return array('path' =>null,'resource' => trim($current,'/'));
}

function resource_selector(){		
	if(isset($_REQUEST['path']) && explode('/',$_REQUEST['path'])[0] != 'initiate'){
		return found_resource(explode('/',$_REQUEST['path']));
	}
	return array('path' =>'initiate.php','resource' => 'initiate');
}

function format_selector(){
	if(empty($_REQUEST['format'])){
		return 'json';
	}
	else if( in_array($_REQUEST['format'],array('json','xml','text')) ){
		return $_REQUEST['format'];
	}
	else throw new BadFormatException();
}

function content_type_selector($format){
	switch($format){
		case 'json' :
			return 'application/json';
		case 'text' :
			return 'text/plain';
		case 'xml' :
			return 'text/xml';
		default :
			return 'text/plain';
	}
}

function parse_data($data,$format){
	switch($format){
		case 'json' :
			return json_encode($data,JSON_PRETTY_PRINT);
		case 'text' :
			return print_r($data,true);
		default :
			return print_r($data,true);
	}
}

function getArrayParam($currentPath,$path)
{
	//$ar = explode($currentPath,$path);
	//array_shift($ar);
	//$param = explode ('/',$ar[0]);
	$param = explode ('/',$path);
	array_shift($param);
	for($i=0;$i<count($param);$i++)
	{
		$param[$i]=trim($param[$i]);
	}
	return $param;
}

//On enclenche la temporisation de sortie (Sauvegarde les echo dans un buffer afin de pouvoir utiliser la commande header() partout".
ob_start();

$http_version = 'HTTP/1.1';
session_start();

try{
	$resource = resource_selector();
	$format = format_selector();
	$method = $_SERVER['REQUEST_METHOD'];
	
	$urlParameters = getArrayParam($resource['resource'],$_REQUEST['path']);
			
	if( !is_file($resource['path'])){
		throw new NotFoundResourceException();
	}
	else include($resource['path']);
	
	if(!function_exists ('check_user_rights') || !function_exists ('run_resource_method')){
		throw new APIResourceErrorException();
	}

	call_user_func('check_user_rights');	
	$arr = call_user_func('run_resource_method');
	
	$content_type = content_type_selector($format);
	
	$header = null;
	if( $method == 'GET' ){
		$header = '200 OK';
	}
	else if( $method == 'POST' ){
		$header = '201 Created';
	}
	
	if( empty($arr) ){
		$header = '204 No Content';
	}
	
	if($header == null ){
		throw new APIResourceErrorException();
	}
}
catch(HTTPException $ex){
	$header = $ex->getHttpErrorFull();
	$content_type = content_type_selector($format);
	$arr['code'] = $ex->getCode();
	$arr['message'] = $ex->getMessage();
}
catch(Exception $ex){
	$httpex = new APIResourceErrorException('Bad Exception type generated by API resource',$ex);
	
	$header = $httpex->getHttpErrorFull();
	$content_type = content_type_selector($format);
	$arr['code'] = $$httpex->getCode();
	$arr['message'] = $httpex->getMessage();
}

header("$http_version $header");
header("Content-Type: $content_type");

//On vide le tempon de sortie et on stoppe le système de tampon
$debug_output =  ob_get_contents();
ob_end_clean();

if( !empty($arr) ){
	$output['meta'] = array('resource' => $resource['resource'],'format'=>$format);
	if(!empty($debug_output)) $output['meta']['debug']['output'] = explode("\n",$debug_output);
	$output['data'] = array($arr);
	
	echo parse_data($output,$format);
}
?>