<?php
function check_user_rights(){
	// CHECK LES DROITS
}

function periodToTimestamp($period, $nb_time)
{
	if($nb_time <= 0)
	{
		throw new InvalidArgumentException();
	}

	switch($period)
	{
		case 'day' :
		case 'days':
			return $nb_time;
		case 'week' :
		case 'weeks':
			return ($nb_time*7);
		case 'month' :
		case 'months':
			$now = new DateTime();
			$date = new DateTime();
			$date->sub(new DateInterval('P'.$nb_time.'M'));
			$ts_now = $now->format('U');
			$ts_date = $date->format('U');

			return ($ts_now - $ts_date)/86400;
		case 'year' :
		case 'years':
			$now = new DateTime();
			$date = new DateTime();
			$date->sub(new DateInterval('P'.$nb_time.'Y'));
			$ts_now = $now->format('U');
			$ts_date = $date->format('U');

			return ($ts_now - $ts_date)/86400;
		default:
			throw new NotFoundResourceException('Incorrect period "'.$period.'" must be days, weeks, month or years.');
	}
}

function run_resource_method(){

	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';

	global $urlParameters;

	$time=1;
	$keyHistory = false;
	$list_errors=array();
	$period = '';
	$nodeId = NULL;
	$serviceId = NULL;
	if(!empty($urlParameters))
	{
		$keyHistory = array_search('history', $urlParameters);
		if($keyHistory !== false) 
		{
			if(!empty($urlParameters[$keyHistory+1]) && is_string($urlParameters[$keyHistory+1]))
			{
				$period = $urlParameters[$keyHistory+1];
			}

			if(!empty($urlParameters[$keyHistory+2]) && is_numeric($urlParameters[$keyHistory+2]))
			{
				$time = $urlParameters[$keyHistory+2];
			}
		}
	}

	// Filters
	if(!empty($_GET['period']) && is_string($_GET['period']))
	{
		$period = $_GET['period'];
	}
	if(isset($_GET['time']) && is_numeric($_GET['time']))
	{
		$time = $_GET['time'];
	}
	if(!empty($_GET['nodeid']) && is_numeric($_GET['nodeid']))
	{
		$nodeId = $_GET['nodeid'];
	}
	if(!empty($_GET['serviceid']) && is_numeric($_GET['serviceid']))
	{
		$serviceId = $_GET['serviceid'];
	}

	try
	{
		if($keyHistory!==false)
		{
			if(!empty($period) && !empty($time))
			{
				$time = periodToTimestamp($period, $time);
			}

			$arr = Model_esia::getAllErrorByTime($dbconnection,$user->getId(),$time, $nodeId, $serviceId);
			foreach($arr as $error)
			{
				$out = preg_replace('#\|.*#',"\n",$error['message']);
				$common_name = Model_esia::getCommonName($lang, $error['plugin_name'], $error['check_plugin_name']);

				$list_errors[]=array('name'=>$error['name'],
						'group'=>$error['group'],
						'group_parent'=>$error['group_parent'],
						'page_control'=>$error['page_control'],
						'id'=>$error['id'],
						'type_device'=>$error['type_device'],
						'type_error'=>$error['type_error'],
						'error'=>$error['error'],
						'message'=>$out,
						'plugin_name'=>$error['plugin_name'],
						'time'=>$error['time'],
						'priority'=>$error['priority'],
						'acquite'=>$error['time_acquitte'],
						'common_name' => $common_name
						);
			}
		}
		else
		{					
			$list_node = Model_esia::getError($dbconnection,$user->getId(),true);			

			//On hierarchise par noeuds, par priorité
			$tmp = array();
			foreach($list_node as $node){
				if( !isset($tmp[$node['id']] ) || ( $node['priority'] < $tmp[$node['id']]['min_prio']) ){
					$tmp[$node['id']]['min_prio'] = $node['priority'];
				}
				$tmp[$node['id']][$node['priority']][$node['type_error']][] = $node;
			}
			$list_errors = $tmp;

			//On nettoye
			$tmp = array();
			foreach($list_errors as $id => $node){
				if( isset( $node[$node['min_prio']]['critical'] ) ){
					$tmp[$id] = $node[$node['min_prio']]['critical'];
				}
				else if( isset( $node[$node['min_prio']]['warning'] ) ){
					$tmp[$id] = $node[$node['min_prio']]['warning'];
				}
				else if( isset( $node[$node['min_prio']]['unknown'] ) ){
					$tmp[$id] = $node[$node['min_prio']]['unknown'];
				}
			}
			$list_errors = $tmp;

			//On presente pour l'affichage
			$tmp = array();
			foreach($list_errors as $id => $node_list){
				foreach($node_list as $node ){
					$common_name = Model_esia::getCommonName($lang, $node['plugin_name'], $node['check_plugin_name']);
					if( !isset($tmp[$node['name']] ) ){
						$keys = array('id','name','group','type_device','page_control','type_error','error','time');
						$row = array();
						foreach($keys as $key){
							$row[$key] = $node[$key];
						}
						$row['common_name'] = array();
						$row['nbre'] = 0;
						$tmp[$node['name']] = $row;
					}
					else{
						if( $tmp[$node['name']]['time'] > $node['time'] ){
							$tmp[$node['name']]['time'] = $node['time'];
						}
					}
					$tmp[$node['name']]['nbre']++;
					$tmp[$node['name']]['common_name'][] = $common_name;
				}
			}
			$list_errors = $tmp;

			foreach($list_errors as $key => $row){
				$list_errors[$key]['common_name'] = implode(',',$row['common_name']);
			}
		}
	}
	catch (HTTPException $e){
		throw $e;
	}
	catch (Exception $e)
	{
		throw new  NotFoundResourceException ("Error alert".$e->getMessage());
	}
	return $list_errors;
}
?>
