<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/api/lib/api_common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';

function check_user_rights(){
    global $user;
    global $dbconnection;
    if($user->getAccess($dbconnection,"esia_administration") != 1){
        throw new AccessDeniedException("This user doesn't have good privileges");
    }
}

function run_resource_method(){
    global $dbconnection;
    global $urlParameters;
    global $method;
    if($method == 'GET' ){
        if (isset($urlParameters[0]) ){
            $settings=Model_esia::getConfiguration($dbconnection,$urlParameters[0]);
            return $settings;
        }
        else if(!empty($_GET['key'])){
            $_POST['key'] = strtoupper($_POST['key']);
            $settings=Model_esia::getConfiguration($dbconnection,$_GET['key']);
            return $settings;
        }
        else if( empty($urlParameters[0])){
            $settings=Model_esia::getConfiguration($dbconnection);
            return array_keys($settings);
        }
        else throw new NotFoundResourceException('Configuration resource GET:'.$urlParameters[0].' not found');
    }
    else if($method == 'POST' ){
        if (!empty($_POST['key']) && !empty($_POST['value'])){
            $_POST['key'] = strtoupper($_POST['key']);
            try{
                $settings=Model_esia::getConfiguration($dbconnection,$_POST['key']);
                if(!array_key_exists('value',$settings[$_POST['key']])) {
                    throw new NotFoundIdException("Configuration key '".$_POST['key']."' not found");
                }
                Model_adm::updateConfiguration($dbconnection,array($_POST['key']=>$_POST['value']));
            }
            catch(EsiaDbException $ex){
                throw new DatabaseErrorException("Error to update key ".$_POST['key']." : ".$ex->getMessage());
            }
            $status = 'updated';
            if( $settings[$_POST['key']]['value'] == $_POST['value'] ){
                $status = 'unchanged';
            }
            return  array(
                'status' => $status,
                'key'=>$_POST['key'],
                'from'=>$settings[$_POST['key']]['value'],
                'to'=>$_POST['value']
            );
        }
        else throw new InvalidParametersException("Missing 'key' or/and 'value' POST parameters");
    }
	else throw new NotFoundMethodException('This method '.$method.' is not implemented for this resource');
}


/*
GET http://127.0.0.1/api/configuration

GET http://127.0.0.1/api/configuration/MAIL_SMTP
or
GET http://127.0.0.1/api/configuration?key='MAIL_SMTP'

POST http://127.0.0.1/api/configuration?key='MAIL_SMTP'&value='ssl0.ovh.net'
*/
