<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/api/lib/api_common.php';
include_once $path.'/plugin/gesa/model_gesa.php';

function check_user_rights()
{
}

//PROD
function getEcatpData($cmd){
    $available_cmd = array('check-ecatp','check-unity-state');
    $exec_path = '/usr/local/esia/plugins';
    $exec_file = 'check_gesa';
    $exec_sn_arg = '0000';
    $exec_cmd = "$exec_path/$exec_file -G $exec_sn_arg -C $cmd";

    if( ! in_array($cmd,$available_cmd) ){
        throw new HttpInternalServerErrorException("Unavailable command $cmd (see resource ecatp code)");
    }

    exec($exec_cmd,$exec_output,$exec_ret);
    if( $exec_ret == 254 ) throw new HttpInternalServerErrorException("Incorrect ecatp version. You must update your ecatp-server");
    if( $exec_ret != 0 ) throw new HttpInternalServerErrorException("Unknown ret value for exec $exec_cmd");

    return $exec_output;
}

//FAKE FOR TEST
/*
function getEcatpData($cmd){
    $available_cmd = array('check-ecatp','check-unity-state');
    $exec_path = '/usr/local/esia';

    if( ! in_array($cmd,$available_cmd) ){
        throw new HttpInternalServerErrorException("Unavailable command $cmd (see resource ecatp code)");
    }

    $exec_file = explode('-',$cmd)[1];
    $exec_cmd = "$exec_path/ecatp.$exec_file.dat";
    $exec_output = file_get_contents($exec_cmd);

    return explode("\n",$exec_output);
}
*/
function checkUnityRights($sn){
    global $dbconnection;
    global $user;

    if( $user->getAccess($dbconnection,'esia_administration') == 1) return true;

    $id = Model_gesa::getGesaIDBySN($dbconnection,intval($sn));
    $obj = Model_gesa::getInstanceGESA($dbconnection,$id);
    return ( $user->getAccess($dbconnection,'device_view',$obj->getName()) == 1);
}


function run_resource_method()
{
	global $urlParameters;
    global $user;
    global $dbconnection;

	$action="list";
	if(isset($_GET['action']))  $action = $_GET['action'];
	$resources = array('status','unity-list','unity');

	if($action=="list"){
        if(empty($urlParameters[0])){
            return $resources;
        }
        else{
            $ret = array();
            switch($urlParameters[0]){
                case 'status' :
                    $data = getEcatpData('check-ecatp');
                    foreach($data as $row){
                        $parsed = explode(':',$row);
                        if( isset($parsed[1])){
                            $ret[$parsed[0]] = $parsed[1];
                        }
                    }
                    break;
                case 'unity-list' :
                    $data = getEcatpData('check-unity-state');
                    foreach($data as $row){
                        $parsed = explode('=',$row);
                        if( isset($parsed[1]) && checkUnityRights($parsed[0])){
                            $ret[$parsed[0]] = $parsed[1];
                        }
                    }
                    break;
                case 'unity' :
                    //echo $urlParameters[1];
                    $all = $mode_sn = false;
                    if(!isset($urlParameters[1])){
                        $all = true;
                    }
                    else if( is_numeric($urlParameters[1])){
                        if( substr($urlParameters[1],0,2) == '20' )
                        {
                            $mode_sn = true;
                        }
                        else
                        {
                        	if(is_numeric($urlParameters[1]))
                        	{
                            	$urlParameters[1] = long2ip($urlParameters[1]);
                        	}
                            $mode_sn = false;
                        }
                    }
                    else{
                        $mode_sn = false;
                    }

                    if(!$all && !$mode_sn)
                    {
                        if( !filter_var($urlParameters[1], FILTER_VALIDATE_IP))
                        {
                            throw new  NotFoundIdException($urlParameters[1]);
                        }
                    }
                    $data = getEcatpData('check-unity-state');
                    foreach($data as $row){
                        if( empty($row) ) continue;
                        $parsed = explode('=',$row);
                        if(!checkUnityRights($parsed[0])) continue;
                        $unity = array(
                            'sn' =>  $parsed[0],
                            'public_ip' => $parsed[1]
                        );
                        if( $all ){
                            $ret[] = $unity;
                        }
                        else if( $mode_sn && $unity['sn'] == $urlParameters[1] ){
                            $ret[] = $unity;
                        }
                        else if ( !$mode_sn && $unity['public_ip'] == $urlParameters[1] ) {
                            $ret[] = $unity;
                        }
                    }
                    break;
                default :
                    throw new NotFoundResourceException('Unity resource '.$urlParameters[0].' not found');
            }
            return $ret;
        }
	}
    else throw new BadFormatException("Unknown action '$action'");
}
?>
