<?php
function check_user_rights(){
	// CHECK LES DROITS
}

//Verifie si un utilisateur posséde des noeuds avec des droits dans un groupe
function is_groupAccess($dbconnection,$user_id,$group_id)
{
	try
	{
		$states = Model_esia::getGroupNodeStates($dbconnection,$user_id,$group_id,false);
	}
	catch(Exception $ex)
	{
		throw new DatabaseErrorException($ex->getMessage());
	}
	foreach(array_shift($states) as $key => $value)
	{ //Parcours des services en (OK,warn,cri,unk,pending)
		if( !empty($value) && $value > 0)
		{
			return true; // minimum 1 service, l'utilisateur a les droits d'access.
		}
	}
	return false; //Tous les status sont à 0
}
function is_groupEmpty($states)
{
	foreach($states as $key => $value)
	{ //Parcours des services en (OK,warn,cri,unk,pending)
		if( !empty($value) && $value > 0)
		{
			return true; // minimum 1 service, l'utilisateur a les droits d'access.
		}
	}
	return false; //Tous les status sont à 0
}



//Recupere une liste (pas une treeview) de tous les groupes de tous les groupes de noeuds
function treeviewToListGroup($treeview,$all=false,$filters=null,&$ret=array(),$parent=null,$level=0,$description=null)
{
	//On vérifier si il y a des filtres
	$is_filtered['name']=false;
	$is_filtered['description']=false;
	$is_filtered['parent']=false;
	$is_filtered['level']=false;
	if(!empty($filters) && is_array($filters))
	{
		foreach($is_filtered as $key => $value)
		{
			$is_filtered[$key] = !empty($filters[$key]);
		}
	}
	
	foreach($treeview as $group)
	{
		if(is_array($group['child'])&&!empty($group['child']))
		{
			if( !$is_filtered['parent'] || in_array($group['name'],$filters['parent']) ||  in_array($group['id'],$filters['parent']))
			{
				treeviewToListGroup($group['child'],$all,$filters,$ret,$group['id'],$level+1);
			}
			if($all)
			{
				foreach($group['child'] as $child)
				{
					$childs[] = $child['id'];
				}
			}
		}
		
		if($is_filtered['name'] && !in_array($group['name'],$filters['name'])) continue;
		if($is_filtered['description'] && !in_array($group['description'],$filters['description'])) continue;
		if($is_filtered['level'] && !in_array($level,$filters['level'])) continue;
		if($is_filtered['parent'] && $level == 0 && !in_array(0,$filters['parent'] )) continue;
		
		$childs = array();
		$state = array('ok'=>$group['ok'],
			'warning'=>$group['warning'],
			'critical'=>$group['critical'],
			'unknown'=>$group['unknown'],
			'pending'=>$group['pending'],
			'maintenance'=>$group['maintenance']);
		$ret[$group['id']] = array(
			'id' => $group['id'],
			'name' => $group['name'],
			'description' => $group['description'],
			'fullpath' => $group['fullpath'],
			'state' => $state,
			'parent' => $group['parent']
		);
		if($all)
		{
			$ret[$group['id']]['level']=$level;
			$ret[$group['id']]['childs']=$childs;
			$ret[$group['id']]['parent']=$parent;
		}
	}
	return $ret;
}

function getChilds($dbconnection,$group_id,$user,$type){
	//Autorisation pour le groupe parent
	$root_access = ( $user->getDroits($dbconnection,'esia_administration') == 1 && $user->getDroits($dbconnection,'esia_device') == 1 );
	if($group_id != 0 && !$root_access && !is_groupAccess($dbconnection,$user->getId(),$group_id))
	{
		throw new NotFoundIdException("Device group $group_id not found");
	}
	
	if($type == 'node')
	{
		try
		{
			if($group_id == 0)
			{
				$nodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),'noGroup',Model_esia::NODE_ASSOC);
			}
			else{
				$nodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),$group_id,Model_esia::NODE_ASSOC);
			}
		}
		catch(Exception $ex)
		{
			throw new DatabaseErrorException($ex->getMessage());
		}
		
		$ORDERSTATES = 'critical,warning,unknown,OK,maintenance,pending';
		$ORDERSTATES = explode(',',$ORDERSTATES);
		$NSTATES = count($ORDERSTATES);
		
		$ret = array();
		foreach($nodeList as $node)
		{
			try
			{
				$nodestates = Model_esia::countNodeState($dbconnection, $node['id']);
			}
			catch(Exception $ex)
			{
				throw new DatabaseErrorException($ex->getMessage());
			}
			$nodeCalcState = 'OK';
			for($i=0;$i<$NSTATES;$i++)
			{
				if($nodestates[$ORDERSTATES[$i]] > 0)
				{
					$nodeCalcState = $ORDERSTATES[$i];
					$i = $NSTATES;//On quitte la boucle
				}
			}
			
			$ret[$node['id']]['id'] = $node['id'];
			$ret[$node['id']]['name'] = $node['name'];
			$ret[$node['id']]['description'] = $node['description'];
			$ret[$node['id']]['state'] = strtolower($nodeCalcState);
		}
		if($group_id != 0 && empty($ret) && empty(Model_adm::getGroupDeviceIn($dbconnection,$group_id)))
			throw new NotFoundIdException("Device group $group_id not found");
			ksort($ret);
			return array_values($ret);
	}
	else if($type == 'group')
	{
		$list_groups = array();
		try
		{
			if( $group_id == 0)
			{
				$list_groups = model_esia::getGroupNodeStates($dbconnection,$user->getId(),NULL,true);
			}
			else
			{
				$list_groups = model_esia::getGroupNodeStates($dbconnection,$user->getId(),$group_id,true);
				if(empty($list_groups))
				{
					//	throw new NotFoundIdException("Device group $group_id not found");
				}
			}
			$ORDERSTATES = 'critical,warning,unknown,ok,maintenance';
			$ORDERSTATES = explode(',',$ORDERSTATES);
			$NSTATES = count($ORDERSTATES);
			
			$ret_grp = array();
			foreach($list_groups as $group)
			{
				$state = array('ok'=>$group['ok'],
					'warning'=>$group['warning'],
					'critical'=>$group['critical'],
					'unknown'=>$group['unknown'],
					'pending'=>$group['pending'],
					'maintenance'=>$group['maintenance']);
				if($root_access || is_groupEmpty($state))
				{
					if( isset($rootGroupStates) )
					{ //Cas du groupe root
						$groupstates = $rootGroupStates[$group['id']];
					}
					$groupCalcState = 'empty';
					for($i=0;$i<$NSTATES;$i++)
					{
						if($group[$ORDERSTATES[$i]] > 0)
						{
							$groupCalcState = $ORDERSTATES[$i];
							$i = $NSTATES;//On quitte la boucle
						}
					}
					$ret_grp[$group['id']] = array('id'=>$group['id'],
						'description'=>$group['description'],
						'fullpath'=>$group['fullpath'],
						'name'=>$group['name'],
						'state'=>$groupCalcState );
				}
				
			}
		}
		catch(Exception $ex)
		{
			throw new DatabaseErrorException($ex->getMessage());
		}
		ksort($ret_grp);
		return array_values($ret_grp);
	}
}

function run_resource_method()
{
	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';
	
	include_once DEVICE_CLASS;
	include_once $path.'/Model_adm.php';
	global $urlParameters;
	
	//Nouveau comportement de l'API
	if(isset($urlParameters[0]) && $urlParameters[0] != 'groupnodeid')
	{
		//Utilisateur root (droits sur tous les groupes) ou utilisateur avec droits restreints ?
		$root_access = ( $user->getDroits($dbconnection,'esia_administration') == 1 && $user->getDroits($dbconnection,'esia_device') == 1 );
		//Quels sont les champs retournés pour chaque groupe ?
		if( empty($_GET['fields']) || strtolower($_GET['fields']) == 'brief' )
		{
			$fields = 'brief';
		}
		else
		{
			$fields = strtolower($_GET['fields']);
		}
		
		//Analyse de la requête
		$p1 = strtolower($urlParameters[0]);
		if($p1 == 'all')
		{
			//Récupération des filtres
			$filters = array();
			foreach(array('name','description','parent','level') as $fkey)
			{
				if( isset($_GET[$fkey]))
				{
					if(is_array($_GET[$fkey]))
					{
						$filters[$fkey] = $_GET[$fkey];
					}
					else
					{ //La variable filter doit toujours contenir des arrays (voir function treeviewToListGroup)
						$filters[$fkey] = array($_GET[$fkey]);
					}
				}
			}
			try
			{
				//$list_groups = Model_adm::getGroupDeviceIn($dbconnection);
				$list_groups = Model_esia::getGroupNodeStates($dbconnection,$user->getId(),null,true);
			}
			catch(Exception $ex)
			{
				throw new DatabaseErrorException($ex->getMessage());
			}
			$list_groups = treeviewToListGroup($list_groups,($fields=='all'),$filters);
			$ret_grp = array();
			foreach($list_groups as $group)
			{
				if($root_access || is_groupEmpty($dbconnection,$user->getId(),$group['id']))
				{
					$ret_grp[$group['id']] = $group;
				}
			}
			ksort($ret_grp);
			return array_values($ret_grp);
		}
		else if($p1 == 0 || $p1 == 'root')
		{
			$group_id = 0;
		}
		else if(is_numeric($p1))
		{
			$group_id = $p1;
		}
		else throw new NotFoundResourceException("Resource $p1 not found");
		
		if(empty($urlParameters[1]))
		{
			
			if($group_id == 0)
			{
				return array(0=>array('id'=>0,'name'=>null));
			}
			$root_access = ( $user->getDroits($dbconnection,'esia_administration') == 1 && $user->getDroits($dbconnection,'esia_device') == 1 );
			try
			{
				$group = Model_esia::getGroupNode($dbconnection,$group_id);
				$group = array_shift($group);
				
				$nodestate = Model_esia::getGroupNodeStates($dbconnection,$user->getId(),$group_id,false);
				$state = array($nodestate['ok'],$nodestate['warning'],$nodestate['critical'],$nodestate['unknown'],$nodestate['pending'],$nodestate['maintenance']);
				if($root_access || is_groupEmpty($state))
				{
					$arr = array('id'=> $group['id'],
						'id'=> $group['id'],
						'name'=> $group['name'],
						'description'=> $group['description']
					);
					return $arr;
				}
				else
				{
					throw new NotFoundIdException("Device group $group_id not found");
				}
			}
			catch(Exception $ex)
			{
				throw new DatabaseErrorException($ex->getMessage());
			}
		}
		else
		{
			
			switch(strtolower($urlParameters[1]))
			{
				case 'nodes' :
					return getChilds($dbconnection,$group_id,$user,'node');
				case 'groups' :
					return getChilds($dbconnection,$group_id,$user,'group');
				case 'childs' :
					$ret['nodes'] = getChilds($dbconnection,$group_id,$user,'node');
					$ret['groups'] = getChilds($dbconnection,$group_id,$user,'group');
					return $ret;
				case 'parents' :
					$parent_id = array_shift(Model_adm::getGroupNode($dbconnection,$group_id))['parent'];
					if( empty($parent_id) ) return NULL;
					return Model_adm::getGroupNode($dbconnection,$parent_id);
				default :
					throw new NotFoundResourceException('Resource '.$urlParameters[2]. ' not found');
			}
		}
	}
	else
	{//Ancien comportement de l'API
		$group = null;
		if (!empty($urlParameters))
		{
			$key_group_node = array_search('groupnodeid', $urlParameters);
			
			if($key_group_node!==false) $group=$urlParameters[$key_group_node+1];
		}
		
		if(isset($_GET['action']))
		{
			$action = $_GET['action'];
		}
		else
		{
			$action="list";
		}
		
		/*$err_treat=0;
		 $dev = new Device();*/
		if($action=="list")
		{
			try
			{
				$select =array();
				$groups = Model_esia::getGroupDeviceIn($dbconnection,$group); //A Optimiser
				foreach($groups as $grp)
				{
					$tmp = convert_tree_to_select($dbconnection,$user->getId(),$grp,0);
					if($tmp[0]['state'] != 'empty'){
						$select = array_merge($select, $tmp);
					}
				}
			}
			catch(Exception $e)
			{
				throw new  DatabaseErrorException ("Unable to get group $group : ".$ex->getMessage());
			}
			if( empty($select) ) throw new NotFoundResourceException ("Node id $group not found");
			return $select;
		}
	}
}


function convert_tree_to_select($dbconnection,$user_id,$top,$itt,$parentid=null,$parentname=null)
{
	$pname=null;
	if(isset($parentname))
	{
		$pname = $parentname.' > '.$top['name'];
	}
	else
	{
		$pname = $top['name'];
	}
	$arr=array();
	
	$state_group = null;
	$state_group = definedStateGroup($dbconnection,$user_id,$top['id']);
	
	$arr[]=array('id'=>$top['id'],'name'=>$top['name'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname,'state'=>$state_group);
	$itt++;
	if(isset($top['child']))
	{
		$tmp=array();
		foreach($top['child'] as $child)
		{
			$tmp = convert_tree_to_select($dbconnection,$user_id,$child,$itt,$top['id'],$pname);
			$arr = array_merge($arr, $tmp);
		}
	}
	return $arr;
}

function is_groupServiceEmpty($state)
{
	$show =true;
	foreach($state as $key => $value)
	{
		if($value!=0)
		{
			$show=false;
			break;
		}
	}
	return $show;
}

function definedStateGroup($dbconnection,$user_id,$id)
{
	$grp = $id;
	
	$NodeList = Model_esia::newgetNodeList($dbconnection,$user_id,$grp,Model_esia::NODE_INSTANCE);
	foreach($NodeList as $node)
	{
		$NodeState = Model_esia::countNodeState($dbconnection, $node->getId());
		$list_node_grp[]=array(
			'id'=>$node->getId(),
			'ok'=>$NodeState['OK'],
			'warning'=>$NodeState['warning'],
			'critical'=>$NodeState['critical'],
			'unknown'=>$NodeState['unknown']);
	}
	$arrs = model_esia::getGroupNodeStates($dbconnection,$user_id,$grp,true);
	$GROUP_NODE_STATE = $arrs;
	//prepare la resquete pour les GroupNodeStat
	foreach($GROUP_NODE_STATE as $top)
	{
		$tmp=null;
		$state='null';
		if(array_key_exists('ok', $top))
		{
			$state = array('ok'=>$top['ok'],'warning'=>$top['warning'],'critical'=>$top['critical'],'unknown'=>$top['unknown']);
		}
		else
		{
			$state = $top['status'];
		}
		//si le groupe est vide on ne l'affiche pas
		if(!is_groupServiceEmpty($state))
		{
			//lien vers le sous groupe
			$page_control="/node_index.php?nodegroup=".$top['id'];
			$list_node_grp[]=array('id'=>$top['id'],
				'ok'=>$state['ok'],
				'warning'=>$state['warning'],
				'critical'=>$state['critical'],
				'unknown'=>$state['unknown']);
		}
	}
	//$ret=$list_node_grp;
	$state = array();
	if(empty($list_node_grp)) return 'empty';
	foreach($list_node_grp as $current)
	{
		$state['ok'] += $current['ok'];
		$state['warning'] += $current['warning'];
		$state['critical'] += $current['critical'];
		$state['unknown'] += $current['unknown'];
		//$state['maintenance'] += $current['maintenance'];
	}
	
	$globalState = "ok";
	if($state["critical"] > 0) { $globalState = "critical"; }
	else if ($state["warning"] > 0) { $globalState = "warning"; }
	else if ($state["unknown"] > 0) { $globalState = "unknown"; }
	//else if ($state["maintenance"] > 0) { $globalState = "maintenance"; }
	
	return $globalState;
}

?>