<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/api/lib/api_common.php';
include_once $path.'/Model_esia.php';

function check_user_rights(){
    global $user;
    global $dbconnection;
    if($user->getAccess($dbconnection,"esia_administration") != 1){
        throw new AccessDeniedException("This user doesn't have good privileges");
    }
}

function run_resource_method(){
    $checklicence="/usr/local/esia/licence/validate_licence";
    global $dbconnection;
    global $urlParameters;
    global $method;
    if($method == 'GET' ){
        try{
            $license['status'] = 'OK';
            $license['message'] = 'Your license is valid';
            $license = array_merge($license,Model_esia::getLicenceInformation($dbconnection));
            $license['max_nodes'] = $license['node'];
            $license['current_nodes'] = Model_esia::countNodeNumberForLicence($dbconnection);
            unset($license['node']);
            return $license;
        }
        catch(Exception $ex){
            $ret['status'] = 'ERROR';
            $ret['message'] = $ex->getMessage();
            return $ret;
        }
    }
    else if($method == 'POST' ){
        if (!empty($_POST['license']))
        {
            try
            {
            	//echo $_POST['license'];
                $flag=Model_esia::updateLicenceInformation($dbconnection,$_POST['license']);
                $licence_type='LICENCE';
                if(preg_match('#Type\:\s?(.*)\n#',$_POST['license'],$regs))
                {
                	if($regs[1]=='Egide'||$regs[1]=='Egide-client')
                	{
                		$licence_type='LICENCE_EGIDE';
                	}
                }
                
                $exec=$checklicence.' -t '.$licence_type;
               // $license['comamnd'] =  $exec;
                $ret=0;
                exec($exec,$output,$ret);
                if( $ret == 0 )
                {
                    $license['status'] = 'OK';
                    $license['message'] = 'Your license is valid';
                    
                    $license = array_merge($license,Model_esia::getLicenceInformation($dbconnection,$licence_type));
                    $license['max_nodes'] = $license['node'];
                    $license['current_nodes'] = Model_esia::countNodeNumberForLicence($dbconnection);
                    unset($license['node']);
                    return $license;
                }
                else{
                    Model_esia::cleanLicenceInformation($dbconnection);
                    if(!is_executable($checklicence))
                    {
                        throw new InternFileAccessException("License validation isn't correctly installed");
                    }
                    else throw new InvalidLicenseException($output[0]);
                }
            }
            catch(Exception $ex)
            {
                if($ex->getMessage() == 'Licence file expired')
                {
                    throw new ExpiredLicenseException('Licence file expired');
                }
                else
                {
                    throw new InvalidLicenseException($ex->getMessage());
                }
            }
        }
        else throw new InvalidParametersException("Missing 'license' POST parameters");
    }
	else throw new NotFoundMethodException('This method '.$method.' is not implemented for this resource');
}
