<?php
function check_user_rights(){
	// CHECK LES DROITS
}

function filter_nodes($nodes){
	$filter_keys = array('id','name','ip','type','group','description');
	$filters = array();
	foreach(array_merge($filter_keys,array('all')) as $fkey){
		if( isset($_GET[$fkey])) {
			if(is_array($_GET[$fkey])){
				$filters[$fkey] = $_GET[$fkey];
			}
			else{ //La variable filter doit toujours contenir des arrays (voir function treeviewToListGroup)
				$filters[$fkey] = array($_GET[$fkey]);
			}
		}
	}

	if(empty($filters)) return $nodes;

	$filtered = array();
	foreach($nodes as $node){
		$found_node=false;

		foreach($filters as $name => $all_values){
			if($name == 'all') continue;
			$found_key = search_in_node($node,$name,$all_values);
			if(!$found_key){
				$found_node = false; //1 des filtre ne matche pas
				break;
			}
			else $found_node = true;
		}
		if(!$found_node && isset($filters['all'])){
			$found_node = search_in_node($node,$filter_keys,$filters['all']);
		}
		if($found_node) $filtered[$node['id']]=$node;
	}

	return $filtered;
}

function search_in_node($node,$keys,$all_values)
{
	if( !is_array($keys)) $keys = array($keys);
	foreach($keys as $name )
	{
		$found_key = false;
		foreach($all_values as $value)
		{
			$str = $node[$name];
			if($name == 'ip')
			{
				if(is_numeric($str))
				{
					$str = long2ip($str);
				}
			}
			if(stripos($str,$value)!== FALSE)
			{
				return true;
			}
		}
	}
	return false;
}

function run_resource_method(){
	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';

	include_once DEVICE_CLASS;
	global $urlParameters;

	$nodeid=null;
	$groupnodeid=null;
	$typeid=null;

	if (!empty($urlParameters))
	{
		$key_node = array_search('nodeid', $urlParameters);
		$key_groupnode = array_search('groupnodeid', $urlParameters);
		$key_type = array_search('type', $urlParameters);

		if($key_node!==false) $nodeid=$urlParameters[$key_node+1];
		if($key_groupnode!==false) $groupnodeid=$urlParameters[$key_groupnode+1];
		if($key_type!==false)
		{
			$key_type=true;
			$typeid=$urlParameters[$key_type+1];
		}
	}

	try
	{
		if(isset($_GET['action']))
		{
			$action = $_GET['action'];
		}
		else
		{
			$action="list";
		}

		if($action=="list")
		{
			try
			{
				$tab_node = array();
				if($key_type==true)
				{
					if($typeid==null) // retourne la page d'accueil avec tous les types de noeuds.
					{
						$arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);
						$total_node=0;
						$total_service=0;
						foreach($arr as $key => $val)
						{
							$tmp = $val['ok']+$val['warning']+$val['critical']+$val['unknown'];
							$list_type[]=array('type'=>$key,
									'nbr_device'=>$val['nbr_device'],
									'nbr_service'=>$tmp,
									'ok'=>$val['ok'],
									'critical'=>$val['critical'],
									'warning'=>$val['warning'],
									'unknown'=>$val['unknown']);
							//calcul du nombre de noeud et de service totaux
							$total_service+=$tmp;
							$total_node += $val['nbr_device'];
						}
						//$list_type['total_node_type'] = count($arr);
						//$list_type['total_node'] = $total_node;
						//$list_type['total_service'] = $total_service;
						return filter_nodes($list_type);
					}
					else // retourne pour un type de noeuds.
					{

					}
				}
				else
				{
					if($nodeid==null && $groupnodeid==null)
					{
						$tab_node = Model_esia::getNodeListWithServicesStats($dbconnection,$user->getId());
						foreach($tab_node as $key => $value)
						{
							if(!is_numeric($value['ip']))
							{
								$tab_node[$key]['ip_string']=$value['ip'];
							}
							else 
							{
								$tab_node[$key]['ip_string']=long2ip($value['ip']);
							}
						}
					}
					elseif($groupnodeid!=null)
					{
						$ORDERSTATES = 'critical,warning,unknown,OK,maintenance,pending';
						$ORDERSTATES = explode(',',$ORDERSTATES);
						$NSTATES = count($ORDERSTATES);

						$NodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),$groupnodeid,Model_esia::NODE_INSTANCE);
						$list_node_grp=array();
						foreach($NodeList as $node)
						{
							//on récupère l'état du noeud
							$NodeState = Model_esia::countNodeState($dbconnection, $node->getId());
							//page de contrôle du noeud
							$page_control = Model_esia::getPageControl($dbconnection, $node->getType());
							if($page_control!=null)
							{
								$page_control = Model_esia::replacePageControlVariable($page_control,$node);
							}
							else
							{
								$page_control = '/node_view.php?nodeid='.$node->getId();
							}

							$nodeCalcState = 'OK';
							for($i=0;$i<$NSTATES;$i++){
								if($NodeState[$ORDERSTATES[$i]] > 0){
									$nodeCalcState = $ORDERSTATES[$i];
									$i = $NSTATES;//On quitte la boucle
								}
							}

							$list_node_grp[]=array(
									'id'=>$node->getId(),
									'name'=>$node->getName(),
									'type'=>$node->getType(),
									'type_img'=>$ICONS[$node->getType()],
									'description'=>$node->getDescription(),
									'ip_address'=>trim($node->getIPv4DecimalAdress()),
									'ip_string' => $node->getIPAddress(),
									'link'=>$page_control,
									'version_snmp'=>$node->getSNMPVersion(),
									'rdp_software'=>$node->getRdpSoftware(),
									'rdp_soft_id'=>$node->getRdpSoftId(),
									'community_snmp'=>$node->getSNMPCommunity(),
									'ok'=>$NodeState['OK'],
									'warning'=>$NodeState['warning'],
									'critical'=>$NodeState['critical'],
									'maintenance'=>$NodeState['maintenance'],
									'pending'=>$NodeState['pending'],
									'state'=> strtolower($nodeCalcState));
						}
						if(empty($list_node_grp) && empty(Model_esia::getGroupDeviceIn($dbconnection,$groupnodeid)))
							 throw new NotFoundIdException("Device group $groupnodeid not found");
						return filter_nodes($list_node_grp);
					}
					else
					{
						$node = array();
						$node = Model_esia::InstanceNode($dbconnection,$nodeid);
                        			$NodeState = Model_esia::countNodeState($dbconnection, $node->getId());
						$page_control = Model_esia::getPageControl($dbconnection, $node->getType());
                                                if($page_control!=null)
                                                {
                                                	$page_control = Model_esia::replacePageControlVariable($page_control,$node);
                                                }
                                                else
                                                {
                                                	$page_control = '/node_view.php?nodeid='.$node->getId();
                                                }

						if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
						{
							$globalState = "ok";
							if($NodeState["critical"] > 0) { $globalState = "critical"; }
							else if ($NodeState["warning"] > 0) { $globalState = "warning"; }
							else if ($NodeState["unknown"] > 0) { $globalState = "unknown"; }
							else if ($NodeState["maintenance"] > 0) { $globalState = "maintenance"; }
							else if ($NodeState["acquitte"] > 0) { $globalState = "acquitte"; }

							$tab_node=array(
							 		'id'=>$node->getId(),
									'name'=>$node->getName(),
									'type'=>$node->getType(),

									'ip_address'=>trim($node->getIPv4DecimalAdress()),
									'ip_string' => $node->getIPAddress(),
									'link'=>$page_control,
									'description'=>$node->getDescription(),
									'version_snmp'=>$node->getSNMPVersion(),														
									'rdp_software'=>$node->getRdpSoftware(),
									'rdp_soft_id'=>$node->getRdpSoftId(),
									'community_snmp'=>$node->getSNMPCommunity(),
									'device_group_name'=>$node->getGroup(),
									'device_group_id'=>$node->getGroupID(),
									'globalState'=>$globalState,
									'ok'=>$NodeState['OK'],'warning'=>$NodeState['warning'],'critical'=>$NodeState['critical'],'unknown'=>$NodeState['unknown'],'pending'=>$NodeState['pending'],'maintenance'=>$NodeState['maintenance'],'acquitte'=>$NodeState['acquitte']
							);
						}
						else
						{
							throw new  AccessDeniedException ("Access denied for this user");
						}
					}
				}
				return filter_nodes($tab_node);
			}
			catch(EsiaDbException $e)
			{
				throw new  NotFoundResourceException ("Resource missing : "+$e->getMessage());
			}
		}
	}
	catch(Exception $e)
	{
        if( is_a($e,'HTTPException') ) throw $e;
		else throw new  NotFoundResourceException ("Error list node");
	}
}
?>