<?php
function check_user_rights(){
	// CHECK LES DROITS
}
function run_resource_method(){

	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';

	global $urlParameters;

	$byservice=null;
	$bynode=null;
	$request_localhost=true;

	if (!empty($urlParameters))
	{
		$key_service = array_search('byservice', $urlParameters);
		if($key_service!==false) $byservice=$urlParameters[$key_service+1];
		$key_node = array_search('bynode', $urlParameters);
		if($key_node!==false) $bynode=$urlParameters[$key_node+1];

		$request_localhost = array_search('localhost', $urlParameters);
	}

	if(isset($_GET['action']))
	{
		$action = $_GET['action'];
	}
	else
	{
		$action="list";
	}

	if($action=="list")
	{
		try
		{
			$rows=array();
			if($bynode==null && $byservice==null)
			{
				if($request_localhost!==false)
				{
					$device_id=array();
					$query = $dbconnection->prepare("SELECT * FROM esia_device WHERE device_ip_address = '127.0.0.1';");
					$query = Model_esia::executeStatement($query,array());
					$row=$query->fetch(PDO::FETCH_OBJ);
					$device_id= $row->device_id;
					$services = Model_esia::getServices($dbconnection,$device_id,null);

					foreach ($services as $service)
					{
						if( ( $user->getAccess($dbconnection,'device_view',$service['device_name']) != 1) ){
							throw new AccessDeniedException("This user doesn't have good privileges");
						}

						if($service['state']==0)$service['state']="ok";
						elseif($service['state']==1)$service['state']="warning";
						elseif($service['state']==2)$service['state']="critical";
						elseif($service['state']==3)$service['state']="unknown";
						elseif($service['state']==4)$service['state']="maintenance";


						if($service['check_plugin_name']=='CHECK_HTTP')
						{
							$rows['ENT_HTTP']['type'] = "sec";
							$rows['ENT_HTTP']['state'] = $service['state'];
							$rows['ENT_HTTP']['value'] = $service['value']['http'];
						}
						elseif ($service['check_plugin_name']=='CHECK_PGSQL')
						{
							preg_match("/time=([0-9]*[,\.][0-9]*)/",$service['stdout'],$match);

							$rows['ENT_DATABASE']['type'] = "sec";
							$rows['ENT_DATABASE']['state'] = $service['state'];
							$rows['ENT_DATABASE']['value'] = $match[1];
						}
						elseif ($service['check_plugin_name']=='CHECK_SNMP_LINUX_IO')
						{
							$rows['diskio']['type'] = "Mb/s";
							$rows['diskio']['state'] = $service['state'];
							$rows['diskio']['value']['read'] = $service['value']['read'];
							$rows['diskio']['value']['write'] = $service['value']['write'];
						}
						elseif ($service['check_plugin_name']=='CHECK_SNMP_LINUX_MEM')
						{
							$rows['ram']['type'] = "percent";
							$rows['ram']['state'] = $service['state'];
							$rows['ram']['value'] = $service['value']['ram'];
							$rows['swap']['type'] = "percent";
							$rows['swap']['state'] = $service['state'];
							$rows['swap']['value'] = $service['value']['swap'];
						}
						elseif ($service['check_plugin_name']=='CHECK_SNMP_LINUX_STORAGE' && preg_match("/-m\s(\\\"\^[\\][\/][$].)/",$service['parameter']))
						{
							$rows['hdd']['type'] = "percent";
							$rows['hdd']['state'] = $service['state'];
							$rows['hdd']['value']['total'] = $service['value']['Total'];
							$rows['hdd']['value']['used'] = $service['value']['Used'];
							$rows['hdd']['value']['hdd'] = $service['value']['hdd'];
						}
						elseif ($service['check_plugin_name']=='CHECK_SNMP_LOAD')
						{
							$rows['cpu']['type'] = "percent";
							$rows['cpu']['state'] = $service['state'];
							$rows['cpu']['value'] = $service['value']['cpu'];
						}
						elseif ($service['check_plugin_name']=='CHECK_ESIA')
						{
							if(preg_match("/OK/",$service['stdout']))
							{
								$rows['ENT_ESIA']['value'] = "running";
							}
							elseif(preg_match("/stopped/",$service['stdout']))
							{
								$rows['ENT_ESIA']['value'] = "stopped";
							}
							else
							{
								$rows['ENT_ESIA']['value'] = "too many daemons";
							}
							$rows['ENT_ESIA']['state'] = $service['state'];
							$rows['ENT_ESIA']['type'] = "state";
						}
					}
					$query = Model_esia::getConfiguration($dbconnection,"SITE_LOCATION");
					$rows['SITE_LOCATION']=$query['SITE_LOCATION']['value'];
				}
			}
			else
			{
				$rows = Model_esia::getServices($dbconnection,$bynode,$byservice);

				$devices = array();
				$services = array();

				foreach($rows as $row){
					//Si on n'a pas encore vérifieé les droits pour le device contenant le service, on le fait.
                    if(!isset($devices[$row['device_name']])){
                        $devices[$row['device_name']] = ($user->getAccess($dbconnection,"device_view",$row['device_name'])==1);
                    }
                    //On vérifie si on a les droits sur le noeud correspondant au service
                    if($devices[$row['device_name']]){
                        $services[] = $row;
                    }
				}
				$rows = $services;
				if(empty($rows)) {
					try{
						Model_esia::InstanceNode($dbconnection,$bynode);
					}
					catch(Exception $ex){
						throw new NotFoundIdException("Node or service not found");
					}
				}

				foreach ($rows as $key=>$value)
				{
					$rows[$key]['common_name'] = Model_esia::getCommonName($lang, $rows[$key]['name'], $rows[$key]['check_plugin_name']);
				}
			}
		}
		catch(EsiaDbException $e)
		{
			throw new  DatabaseErrorException ($e->getMessage());
		}
	}

	$STR_STATES = array('ok','warning','critical','unknown');
	foreach($rows as $key => $row){
		$tmp = array();
		$ksearch = array('last_exec_time','added_time','stdout');
		foreach($row as $k => $v){
			$tmp[$k] = $v;
			if(in_array($k,$ksearch)){
				if($k == 'last_exec_time'){
					$tmp['last_exec_ts'] = strtotime($v);
				}
				elseif($k == 'added_time'){
					$tmp['added_ts'] = strtotime($v);
				}
				else{
					$exp = explode('|',$v,2);
					$tmp['stdout'] = trim($exp[0]);
					if(isset($exp[1])) $tmp['graph'] = trim($exp[1]);
					else $tmp['graph'] == null;
				}
			}
		}
		$state = $tmp['state'];
		$rstate = $tmp['real_state'];

		if(empty($tmp['last_exec_time'])){
			$str_state = 'pending';
		}
		else if( $rstate == 5 ){
			$str_state = 'maintenance';
		}
		else if($state == $rstate){
			if( isset($STR_STATES[$state]) ){
				$str_state = $STR_STATES[$state];
			}
		}
		else{
			$str_state = 'acquitted';
		}

		$tmp['name_state'] = $str_state;
		$rows[$key] = $tmp;
	}

	return $rows;
}

?>
