<?php
function check_user_rights(){}

function getSystemServiceState($service){
	$ret = array();
	$cmd = 'service '.$service. ' status';
	exec($cmd,$output);
	if(empty($output)) return array( 'status' => 'unavailable' );
	foreach($output as $key => $row){
		if( $key == 0 && preg_match('#(\S+)\.service\W+([^"]*)#',$row,$matches) ){
			$ret['name'] = $matches[1];
			$ret['description'] = $matches[2];
		}
		else if( preg_match('#Active:\s*(\w+)\s*\((\w+)\)\s*since\s([^;]+);\s*([^"]+)#',$row,$matches) ){
			if( $matches[1] == 'inactive' && $matches[2] == 'dead' )        $ret['status'] = 'halted';
			else if( $matches[1] == 'active' && $matches[2] == 'running' )  $ret['status'] = 'running';
			else $ret['status'] == 'unknown';
			$ret['service_status'] = $matches[1];
			$ret['process_status'] = $matches[2];
			$ret['since'] = $matches[3];
			$ret['timelaps'] = $matches[4];
		}
		else if ( isset($ret['status']) && $ret['status'] == 'running' && preg_match('#Tasks:\s*(\d+)\s*\(limit:\s+(\d+)\)#',$row,$matches) ){
			$ret['tasks'] = $matches[1];
			$ret['tasks_limit'] = $matches[2];
		}
	}
	return $ret;
}

function getSystemSettingsState($settings){
    $conffiles['ini']['esia'] = '/etc/esia/esia.conf';
    $conffiles['ini']['ecatp-server'] = '/etc/esia/ecatp.conf';

    $content_file = file_get_contents($conffiles['ini'][$settings]);
    if( $content_file === FALSE ) throw new HttpNotFoundException('Unable to found or access to '.$conffiles['ini'][$settings]);

    //Suppresion des commentaires unix '#' utilisé par Esia. Normalement un fichier ini utilise ; comme commentaire
    $content_file = explode("\n",$content_file);
    $ret = array();
    $key='none';
    foreach($content_file as $row){
        $exp = explode('#',$row);
        $row = trim($exp[0]);
        if(!empty($row)){
            if( preg_match('/^\[(\w+)\]/',$row,$matches) !== FALSE && isset($matches[1])){
                $key = $matches[1];
            }
            else if( preg_match('/^\s*(\w+)\s*=\s*(\S+)\s*/',$row,$matches) !== FALSE && isset($matches[2]) ){
                $ret[$key][$matches[1]] = $matches[2];
            }
        }
    }

    //On ne retourne pas les parmètres d'authentication database pour des raisons de sécurité alors que l'informations est inutile
    if($settings == 'esia' ){
        unset($ret['POSTGRESQL']);
    }

    return $ret;
}

function run_resource_method(){
	global $urlParameters;
	$action="list";
	if(isset($_GET['action']))  $action = $_GET['action'];

	if($action=="list"){
		$system_list = array('service','settings');
		if(empty($urlParameters)){
			return $system_list;
		}
		else if( $urlParameters[0] == 'service' ){
			$services_list = array('cron','ecatp-server','esia','postgresql','apache2');

			if(empty($urlParameters[1])) return $services_list;
			else if( in_array($urlParameters[1],$services_list) ){
				$ret =  getSystemServiceState($urlParameters[1]);
			}
		    else if( $urlParameters[1] == 'all' ){
		        $ret = array();
		        foreach($services_list as $service){
		            $ret[] = getSystemServiceState($service);
		        }
		    }
			else throw new NotFoundResourceException('Service '.$urlParameters[1].' not found');

			return $ret;
		}
		else if( $urlParameters[0] == 'settings' ){
			$settings_list = array('ecatp-server','esia');

			if(empty($urlParameters[1])) return $settings_list;
			else if( in_array($urlParameters[1],$settings_list) ){
				$ret =  getSystemSettingsState($urlParameters[1]);
			}
		    else if( $urlParameters[1] == 'all' ){
		        $ret = array();
		        foreach($settings_list as $settings){
		            $ret[] = getSystemSettingsState($settings);
		        }
		    }
			else throw new NotFoundResourceException('Settings '.$urlParameters[1].' not found');

			return $ret;
		}

		else throw new NotFoundResourceException('System resource '.$urlParameters[0].' not found');
	}
	else throw new BadFormatException("Unknown action '$action'");
}
