<?php
function check_user_rights(){}

function getUnitysIdNameList($dbconnection,$user){
    try{
	    $nodes = Model_esia::getNodebyType($dbconnection,$user->getId(),'gesa');
	}
	catch(EsiaDbException $ex){
	    throw new DatabaseErrorException("Unable to get Unity list",$ex);
	}
	foreach($nodes as $node){
	    $ret[$node->getId()] = $node->getName();
	}
	return $ret;
}

function unityToArray($node){
    $tab_node=array(
        'id'=>$node->getId(),
        'name'=>$node->getName(),
        'type'=>$node->getType(),
        'ip_address'=>$node->getIPv4DecimalAdress(),
        'description'=>preg_replace('#\n#','<br />',$node->getDescription() ),
        'version_snmp'=>$node->getSNMPVersion(),
        'rdp_software'=>$node->getRdpSoftware(),
        'rdp_soft_id'=>$node->getRdpSoftId(),
        'community_snmp'=>$node->getSNMPCommunity(),
        'device_group_name'=>$node->getGroup(),
        'device_group_id'=>$node->getGroupID(),
        'unity_sn'=>$node->getSerialNumber(),
        'public_address'=>$node->getPublicIPaddress(),
        'private_address'=>$node->getLocalIPaddress(),
    );
    return $tab_node;
}

function getFullUnityData($dbconnection,$id){
    $obj = Model_gesa::getInstanceGESA($dbconnection,$id);
    $ret = unityToArray($obj);

    $ret['linked_nodes'] = array();
    $linked_nodes = Model_gesa::getNodeLink($dbconnection,$ret['id']);
    foreach($linked_nodes as $node){
        $ret['linked_nodes'][] = $node['id'];
    }

    $ret['services_nb'] = Model_gesa::count_service_execute($dbconnection,$ret['id']);

    $ret['page_control'] = Model_esia::getPageControl($dbconnection,$obj->getType());
    //Rempalcer :id par l'id correspondant pour la page de contrôle
    $pattern = "/:id/";
    $ret['page_control'] = preg_replace($pattern,$ret['id'],$ret['page_control']);
    return $ret;
}

function run_resource_method(){
    $path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';
	include_once DEVICE_CLASS;
	include_once $path.'/plugin/gesa/model_gesa.php';

	global $urlParameters;
	$action="list";
	if(isset($_GET['action']))  $action = $_GET['action'];

	if($action=="list"){
		if(empty($urlParameters[0])){
		    return getUnitysIdNameList($dbconnection,$user);
		}
		else{
		    try{
		        switch($urlParameters[0]){
		            case 'all' :
		                $list = getUnitysIdNameList($dbconnection,$user);
		                $ret = array();
		                foreach($list as $id => $name){
		                    $ret[] = getFullUnityData($dbconnection,$id);
		                }
		                break;
		            case 'unityid' :
		                $unity_id = $urlParameters[1];
		                $is_sn = false;
		                if( is_numeric($unity_id) && $unity_id > 201700000000 ){ //ID or SN
		                    $is_sn = true;
		                }
		                else{ //name or sn
		                    if(preg_match('#([0-9]{8})\-([0-9]{2})\-([0-9]*)#', $sn, $regs))
		                    {
		                        $is_sn=true;
			                    $unity_id=$regs[1].$regs[2].$regs[3];
		                    }
		                }
		                if( $is_sn ){
		                    $id = Model_gesa::getGesaIDBySN($dbconnection,intval($unity_id));
		                    if( $id !== false) $unity_id = $id;
		                }
		                try{
		                    $fields = getFullUnityData($dbconnection,$unity_id);
		                }
		                catch(EsiaDbException $ex){
		                    throw new NotFoundResourceException("Unity $unity_id not found");
		                }
		                if( $user->getAccess($dbconnection,'device_view',$fields['name'])){
		                    $ret = $fields;
		                }
		                else throw NotFoundResourceException('Device '.$urlParameters[1]. 'not found');
		                break;
		            case 'groupid' :
		                $list = Model_esia::newgetNodeList($dbconnection,$user->getId(),$urlParameters[1],Model_esia::NODE_INSTANCE);
		                $ret = array();
		                foreach($list as $node){
		                    if( $node->getType() == 'gesa' ){
		                        $ret[] = getFullUnityData($dbconnection,$node->getId());
		                    }
		                }
		                break;
		            default :
		                throw new NotFoundResourceException('Unity resource '.$urlParameters[0].' not found');
		        }
		    }
		    catch(EsiaDbException $ex){
	            throw new DatabaseErrorException("Unable to get Unity data",$ex);
	        }
		    return $ret;
		}
	}
	else throw new BadFormatException("Unknown action '$action'");
}
