<?php
//Recupérerer le dbconnection
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include $path.'/esia.conf.php';
include_once USR_CLASS;
include_once LIB_LOG;
include_once MVCMODEL;

try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	throw new DatabaseConnectionException();
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

//Vérifier si l'user est authentifié 
try {
	$user = new User($dbconnection);
	$user->sessionIDisValid(Model_esia::getDuringSession($dbconnection));
}
catch(UserException $e)	//Il n'est pas connecté
{
	throw new NotAuthenticatedException();
}

if($user->getLang()!="")
{
	//configuration de la langue de l'application
	include $path.'/lang/'.$user->getLang().'/'.$user->getLang().'.php';
	include $path.'/lang/'.$user->getLang().'/common_plugin_name.php';
}
else
{
	include $path.'/lang/'.LANG.'/'.LANG.'.php';
	include $path.'/lang/'.LANG.'/common_plugin_name.php';
}

?>
